\section{Basic Concepts}

\subsection{Data Types}

\subsection{Expressions}
In Python \lstinline|2 + 2| is called an expression, which ist he most basic kind of programming instruction in the language. Expressions consist of values (such as 2) and operators (such as +), and they can always evaluate down to a single value. This means we can use expressions everywhere where we can use values.

The order of operations (also called precedence) of Python math operators is similar to that of the mathematics. Python will keep evaluating parts of the expression until it becomes a single value.

\begin{figure}[h!]
 	\center
	\includegraphics[width=0.75\textwidth]{operators}
	\caption{Operators}
\end{figure}

\subsection{Strings Concatenation and Replication}
The meaning of operators does change based on the used data type of the values next to it. For example of we add \lstinline|+| to two strings we concatenate the two. 

\subsection{Variable Names}
We can name nearly everything in Python as we want as long we follow the three rules:
\begin{itemize}
	\itemsep -0.45em
	\item It can be only one word with no spaces
	\item It can use only letters, numbers and the underscore character
	\item It can't begin with a number	
\end{itemize}

Variable names are case-sensitive. It is a Python convention to start our variables with a lowercase letter. The best practice is to use underscore in the variable names.

\begin{lstlisting}
my_name = 'Marco Agostini'
\end{lstlisting}

\subsection{Simple Programm}
In the following section we cover a simple Python program in order to cover the most basics functions available to the programer.

\begin{description}
	\item [print() Function] displays the string value inside its parentheses on the screen.
	\item [fomrat() Function] is a function for strings, the method formats the specified value(s) and insert them inside the string's placeholder.
	\item [input() Function] waits for the user to input some text on the keyboard and press enter (blocking).
	\item [len() Function] is a string function and the function evaluates to the integer value of the number of characters in the string.
\end{description}

\lstinputlisting{src/basic/HelloWorld.py}


\section{Flow Control}
In computer programming, control flow or flow of control is the order function calls, instructions, and statements are executed or evaluated when a program is running.

\subsection{Boolean Values}
While the integer, floating-point, and string data types have an unlimited number of possible values, the Boolean data type has only two values: True and False. When entered as Python code, the Boolean values True and False lack the quotes you place around strings, and they always start with a capital T or F, with the rest of the word in lowercase. 

\begin{lstlisting}
spam = True
\end{lstlisting}

\subsection{Comparison Operators}
Comparison operators, also called relational operators, compare two values and eval- uate down to a single Boolean value. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.4\textwidth]{comparisonoperators}
  \caption{Comparison Operators}
\end{figure}

\subsection{Boolean Operators}
The three Boolean operators (and, or, and not) are used to compare Boolean values. Like comparison operators, they evaluate these expressions down to a Boolean value.

\begin{lstlisting}
True and False
True or False
True and not False
(4 < 5) and (5 < 6)
\end{lstlisting}

\subsection{Elements of Flow Control}
Flow control statements often start with a part called the condition and are always followed by a block of code called the clause.

\begin{description}
	\item [Conditions] The Boolean expressions you’ve seen so far could all be considered conditions, which are the same thing as expressions; condition is just a more specific name in the context of flow control statements. Conditions always evaluate down to a Boolean value, True or False.
	\item [Blocks of Code] Lines of Python code can be grouped together in blocks. You can tell when a block begins and ends from the indentation of the lines of code.
\end{description}

\lstinputlisting{src/basic/conditions.py}


\subsubsection{Branch Statements}
The most common type of flow control statement is the if statement. An if statements clause (that is, the block following the if statement) will execute if the statement’s condition is True.

An if clause can optionally be followed by an else statement. The else clause is executed only when the if statements condition is False.

Conditions will consider some values in other data types equivalent to True and False. When used in conditions, 0, 0.0, and $''$ (the empty string) are considered False, while all other values are considered True

While only one of the if or else clauses will execute, you may have a case where you want one of many possible clauses to execute. 

\lstinputlisting{src/basic/if.py}

\subsubsection{Loop Statements}
You can make a block of code execute over and over again using a while statement. The code in a while clause will be executed as long as the while statement’s condition is True.

\begin{lstlisting}
spam = 0
while spam < 5:
	print('hello, world')
	spam = spam + 1
\end{lstlisting}

There is a shortcut to getting the program execution to break out of a while loop’s clause early. If the execution reaches a break statement, it immediately exits the while loop’s clause. In code, a break statement simply contains the break key word.

\lstinputlisting{src/basic/break.py}

Like break statements, continue statements are used inside loops. When the program execution reaches a continue statement, the program execution immediately jumps back to the start of the loop and reevaluates the loop’s condition.

\paragraph{For Loops}
The while loop keeps looping while its condition is True (which is the reason for its name), but what if you want to execute a block of code only a certain number of times? You can do this with a for loop statement and the range() function.

\begin{lstlisting}
print('My name is') 
for i in range(5):     
	print('Jimmy Five Times (' + str(i) + ')')
\end{lstlisting}

Some functions can be called with multiple arguments separated by a comma, and range() is one of them. This lets you change the integer passed to range() to follow any sequence of integers, including starting at a number other than zero.

\begin{lstlisting}
for in in range(12, 16):
	print(i)
# Output: 12 13 14 15
\end{lstlisting}

The range() function can also be called with three arguments. The first two arguments will be the start and stop values, and the third will be the step argument. The step is the amount that the variable is increased by after each iteration.

\begin{lstlisting}
for i in range(0, 10, 2):    
	print(i)
# Output: 0 2 4 6 8 
\end{lstlisting}

\subsection{Importing Modules}
All Python programs can call a basic set of functions called built-in functions, including the print(), input(), and len() functions you’ve seen before. Python also comes with a set of modules called the standard library. Each module is a Python program that contains a related group of functions that can be embedded in your programs. For example, the math module has mathematics- related functions, the random module has random number-related functions, and so on.

Once you import a module, you can use all the cool function of that module.

\begin{lstlisting}
import random
for i in range(5):
	print(random.randint(1,100))	
\end{lstlisting}

\section{Functions}
Python provides several builtin functions like these, but you can also write your own functions. A function is like a miniprogram within a program. A major purpose of functions is to group code that gets executed multiple times. Without a function defined, you would have to copy and paste this code each time.

To define a function is to create it, just like an assignment statement like \lstinline|spam = 42| creates the spam variable. The def statement defines the function. The \lstinline|hello()| statement calls the create function. With this function call we can pass values to the function. A value being passed to a function in a function call is an argument. Variables that have arguments assigned to them are parameters.

\begin{lstlisting}
def hello():
	print('Howdy!')
	print('Howdy!!')
	print('Howdy!!!')
hello()
\end{lstlisting}

When you call the print() or len() function, you pass them values, called arguments, by typing them between the parentheses. You can also define your own functions that accept arguments.

\begin{lstlisting}
def hello(name):
	print('Hello, ' + name)
hello('Alice')
\end{lstlisting}


\subsection{Return Values and Return Statements}
When you call the len() function and pass it an argument such as 'Hello', the function call evaluates to the integer value 5, which is the length of the string you passed it. In general, the value that a function call evaluates to is called the return value of the function.

\begin{lstlisting}
r = random.randint(1, 9) 
fortune = getAnswer(r) 
print(fortune)
# Or the better equivalent
print(getAnswer(random.randint(1, 9)))
\end{lstlisting}

\paragraph{None Value}
In Python, there is a value called None, which represents the absence of a
value. The None value is the only value of the NoneType data type. (Other programming languages might call this value null, nil, or undefined.) Behind the scenes, Python adds return None to the end of any function definition with no return statement.

One place where None is used is as the return value of print(). The print() function
displays text on the screen, but it doesn’t need to return anything in the same way len() or input() does. But since all function calls need to evaluate to a return value, print() returns None. 

\begin{lstlisting}
spam == print('Hello')
None == spam  # True
\end{lstlisting}

\subsection{Keyword Arguments}
Most arguments are identified by their position in the function call. However, rather than through their position, keyword arguments are identified by the keyword put before them in the function call. Keyword arguments are often used for optional parameters. For example, the print() function has the optional parameters end and sep to specify what should be printed at the end of its arguments and between its arguments (separating them), respectively.

\begin{lstlisting}
print('Hello', end='')
print('World')
# Ouput = HelloWorld

print('cats', 'dogs', 'mice', sep=',') 
# Ouput = cats,dogs,mice
\end{lstlisting}

The output is printed on a single line because there is no longer a newline printed after 'Hello'. Instead, the blank string is printed.

\subsection{The Call Stack}
Calling a function doesn’t send the execution on a one-way trip to the top of a function. Python will remember which line of code called the function so that the execution can return there when it encounters a return statement. If that original function called other functions, the execution would return to those function calls first, before returning from the original function call.

The call stack is how Python remembers where to return the execution after each function call. The call stack isn’t stored in a variable in your program; rather, Python handles it behind the scenes. When your program calls a function, Python creates a \textit{frame object} on the top of the call stack. Frame objects store the line number of the original function call so that Python can remember where to return. If another function call is made, Python puts another frame object on the call stack above the other one. When a function call returns, Python removes a frame object from the top of the stack and moves the execution to the line number stored in it. 

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{frameobjects}
  \caption{Frame Objects Example}
\end{figure}

\subsection{Local and Global Scope}
Parameters and variables that are assigned in a called function are said to exist in that function’s local scope. Variables that are assigned outside all functions are said to exist in the global scope. A variable that exists in a local scope is called a local variable, while a variable that exists in the global scope is called a global variable. A variable must be one or the other; it cannot be both local and global.

Think of a scope as a container for variables. When a scope is destroyed, all the values stored in the scope’s variables are forgotten. There is only one global scope, and it is created when your program begins. When your program terminates, the global scope is destroyed, and all its variables are forgotten. Otherwise, the next time you ran a program, the variables would remember their values from the last time you ran it.

A local scope is created whenever a function is called. Any variables assigned in the function exist within the function’s local scope. When the function returns, the local scope is destroyed, and these variables are forgotten.

\paragraph{Why Scopes Matter:}
\begin{itemize}
	\item Code in the global scope, outside of all functions cannot use any local variables
	\item Code in local scope can access global variables
	\item Code in a functions local scope cannot use variables in any other local scope
	\item You can use the same name for different variable if the are in different scopes. That is, there can be a local variable named span and a global variable also named spam.
\end{itemize}

The reason Python has different scopes instead of just making everything a global variable is so that when variables are modified by the code in a particular call to a function, the function interacts with the rest of the program only through its parameters and the return value. This narrows down the number of lines of code that may be causing a bug. If your pro- gram contained nothing but global variables and had a bug because of a variable being set to a bad value, then it would be hard to track down where this bad value was set. It could have been set from anywhere in the pro- gram, and your program could be hundreds or thousands of lines long! But if the bug is caused by a local variable with a bad value, you know that only the code in that one function could have set it incorrectly.

\begin{lstlisting}
def spam():
	not_eggs = 43 # local variable
	print(eggs)
eggs = 42 # global variable
spam()
\end{lstlisting}

\paragraph{The global Statement}
If you need to modify a global variable from within a function, use the global statement. If you have a line such as global eggs at the top of a function, it tells Python, In this function, eggs refers to the global variable, so don’t create a local variable with this name.

\begin{lstlisting}
def spam():
	global eggs
	eggs = 'spam'
eggs = 'global'
spam()
print(eggs) # prints spam
\end{lstlisting}

\paragraph{Rules}
There are four rules to tell whether a variable is in local scope or global scope:
\begin{itemize}
	\item If a variable is being used in the global scope (that is, outside of all functions), then it is always a global variable. 
	\item  If there is a global statement for that variable in a function, it is a global variable. 
	\item Otherwise, if the variable is used in an assignment statement in the function, it is a local variable. 
	\item But if the variable is not used in an assignment statement, it is a global variable.
\end{itemize}

\subsection{Exception Handling}
Right now, getting an error, or exception, in your Python program means the entire program will crash. You don’t want this to happen in real-world programs. Instead, you want the program to detect errors, handle them, and then continue to run. Errors can be handled with try and except statements. The code that could potentially have an error is put in a try clause. The program execution moves to the start of a following except clause if an error happens.

\begin{lstlisting}
def spam(divideBy):
	try:
		return 42 / divideBy
	except ZeroDivisionError:
		print('Error: invalid argument')
\end{lstlisting}

